
// plugin_demo.cpp : 定义应用程序的类行为。
//

#include "stdafx.h"
#include "demo.h"
#include "demoBeforeLoginDlg.h"
#include "demoMainMenuDlg.h"
#include "HwmSdkAgent.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// Cdemo

BEGIN_MESSAGE_MAP(Cdemo, CWinApp)
    ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// Cdemo 构造

Cdemo::Cdemo() : m_iDialog(0), m_pCurDlgWnd(nullptr)
{
    // 支持重新启动管理器
    m_dwRestartManagerSupportFlags = AFX_RESTART_MANAGER_SUPPORT_RESTART;

    // TODO: 在此处添加构造代码，
    // 将所有重要的初始化放置在 InitInstance 中
}

Cdemo::~Cdemo()
{
}

// 唯一的一个 Cdemo 对象

Cdemo theApp;


// Cdemo 初始化

BOOL Cdemo::InitInstance()
{
    // 如果一个运行在 Windows XP 上的应用程序清单指定要
    // 使用 ComCtl32.dll 版本 6 或更高版本来启用可视化方式，
    //则需要 InitCommonControlsEx()。  否则，将无法创建窗口。
    INITCOMMONCONTROLSEX InitCtrls;
    InitCtrls.dwSize = sizeof(InitCtrls);
    // 将它设置为包括所有要在应用程序中使用的
    // 公共控件类。
    InitCtrls.dwICC = ICC_WIN95_CLASSES;
    InitCommonControlsEx(&InitCtrls);

    CWinApp::InitInstance();


    AfxEnableControlContainer();

    // 创建 shell 管理器，以防对话框包含
    // 任何 shell 树视图控件或 shell 列表视图控件。
    CShellManager *pShellManager = nullptr;
    try
    {
        pShellManager = new CShellManager;
    }
    catch(...)
    {
        return FALSE;
    }

    // 激活“Windows Native”视觉管理器，以便在 MFC 控件中启用主题
    CMFCVisualManager::SetDefaultManager(RUNTIME_CLASS(CMFCVisualManagerWindows));

    // 标准初始化
    // 如果未使用这些功能并希望减小
    // 最终可执行文件的大小，则应移除下列
    // 不需要的特定初始化例程
    // 更改用于存储设置的注册表项
    // TODO: 应适当修改该字符串，
    // 例如修改为公司或组织名
    SetRegistryKey(_T("应用程序向导生成的本地应用程序"));
    //默认首窗口为登录窗口
    m_iDialog = 1;
    //当m_iDialog为0时退出
    while (m_iDialog)
    {
        switch (m_iDialog)
        {
            //登录窗口
            case 1:
            {
                CdemoBeforeLoginDlg dlg;
                m_pCurDlgWnd = &dlg;
                INT_PTR nResponse = dlg.DoModal();
                if (nResponse == IDOK)
                {
                    //下一个显示主窗口
                    m_iDialog = 2;
                }
                else if (nResponse == IDCANCEL)
                {
                    //关闭对话框时退出应用
                    int ret = hwmsdkagent::Exit();
                    m_iDialog = 0;
                }
                else if (nResponse == -1)
                {
                    TRACE(traceAppMsg, 0, "警告: 对话框创建失败，应用程序将意外终止。\n");
                    TRACE(traceAppMsg, 0, "警告: 如果您在对话框上使用 MFC 控件，则无法 #define _AFX_NO_MFC_CONTROLS_IN_DIALOGS。\n");
                    //退出应用
                    m_iDialog = 0;
                }
                break;
            }
            //主窗口
            case 2:
            {
                demoMainMenuDlg dlgMain;
                m_pCurDlgWnd = &dlgMain;
                INT_PTR nMainResponse = dlgMain.DoModal();
                if (nMainResponse == IDOK)
                {
                    //下一个显示登录窗口
                    m_iDialog = 1;
                }
                else if (nMainResponse == IDCANCEL)
                {
                    //关闭对话框时退出应用
                    int ret = hwmsdkagent::Exit();
                    m_iDialog = 0;
                }
                else if (nMainResponse == -1)
                {
                    TRACE(traceAppMsg, 0, "警告: 对话框创建失败，应用程序将意外终止。\n");
                    TRACE(traceAppMsg, 0, "警告: 如果您在对话框上使用 MFC 控件，则无法 #define _AFX_NO_MFC_CONTROLS_IN_DIALOGS。\n");
                    //退出应用
                    m_iDialog = 0;
                }
                break;
            }
            default:
            {
                //退出应用
                m_iDialog = 0;
                break;
            }
        }
        m_pCurDlgWnd = 0;
    }

    // 删除上面创建的 shell 管理器。
    if (pShellManager != NULL)
    {
        delete pShellManager;
        pShellManager = nullptr;
    }

#ifndef _AFXDLL
    ControlBarCleanUp();
#endif

    // 由于对话框已关闭，所以将返回 FALSE 以便退出应用程序，
    //  而不是启动应用程序的消息泵。
    return FALSE;
}

